> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.gappify.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.gappify.com/_mcp/server.

# Create a new or update existing Fx Rates entries.

POST https://api.gappify.com/v1/fx-rates
Content-Type: application/json

Create a new or update existing FX Rates entries with the provided data.

## Required Fields Summary

| Field              | Type   | Description                                                    |
| ------------------ | ------ | -------------------------------------------------------------- |
| `source_system_id` | string | ERP id which uniquely represents the specific FX rate value    |
| `period`           | date   | FX rate applicable period.⚠️ **Required format:** `yyyy-mm-01` |
| `from_currency`    | string | The currency being converted from (ISO code)                   |
| `to_currency`      | string | The currency being converted to (ISO code)                     |
| `rate`             | double | FX rate value (limit to 5 decimal places)                      |

Reference: https://developers.gappify.com/api-reference/inbound-to-gappify/6/post

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Servers

- `https://api.gappify.com/v1` (Production, default)
- `https://api.uat.gappifyinc.com/v1` (UAT)

## Request

### Body (application/json)

This endpoint expects a list of FxRatesPostPayload.

- `list of FxRatesPostPayload`

## Response

### 202

- `request_id` (UUID, required) — Unique identifier for the request
- `status` ("IN_PROGRESS", required) — Status of the request

## Errors

### 401 Unauthorized Error

- `message` (string, required) — The error message
- `success` (boolean, required)

### 422 Unprocessable Entity Error

- `message` (string, required) — The error message
- `errors` (string, required) — The error details

### 404 Not Found Error

- `list of string`

### 500 Internal Server Error

- `list of string`

## Types

### FxRatesPostPayload

- `source_system_id` (string, required) — ERP id which uniquely represents the specific fx rate value. This value will be used to match source data and perform upserts.
- `period` (date, required) — FX rate applicable period.&#x20; **Format:** `yyyy-mm-01` (e.g., `2026-03-01`).
- `from_currency` (string, required) — The currency being converted from. The value should match the g_name of the currency in source_coas. Use the ISO code of the currency.
- `to_currency` (string, required) — The currency being converted to. The value should match the g_name of the currency in source_coas. Use the ISO code of the currency.
- `rate` (double, required) — FX rate value. Limit to 5 decimal places.

## Examples

**Request**

```json
[
  {
    "source_system_id": "source_system_id",
    "period": "2023-01-15",
    "from_currency": "from_currency",
    "to_currency": "to_currency",
    "rate": 1.1
  },
  {
    "source_system_id": "source_system_id",
    "period": "2023-01-15",
    "from_currency": "from_currency",
    "to_currency": "to_currency",
    "rate": 1.1
  }
]
```

**Response**

```json
{
  "request_id": "d5e9c84f-c2b2-4bf4-b4b0-7ffd7a9ffc32",
  "status": "IN_PROGRESS"
}
```

**SDK Code**

```python
import requests

url = "https://api.gappify.com/v1/fx-rates"

payload = [
    {
        "source_system_id": "source_system_id",
        "period": "2023-01-15",
        "from_currency": "from_currency",
        "to_currency": "to_currency",
        "rate": 1.1
    },
    {
        "source_system_id": "source_system_id",
        "period": "2023-01-15",
        "from_currency": "from_currency",
        "to_currency": "to_currency",
        "rate": 1.1
    }
]
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.gappify.com/v1/fx-rates';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '[{"source_system_id":"source_system_id","period":"2023-01-15","from_currency":"from_currency","to_currency":"to_currency","rate":1.1},{"source_system_id":"source_system_id","period":"2023-01-15","from_currency":"from_currency","to_currency":"to_currency","rate":1.1}]'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.gappify.com/v1/fx-rates"

	payload := strings.NewReader("[\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"period\": \"2023-01-15\",\n    \"from_currency\": \"from_currency\",\n    \"to_currency\": \"to_currency\",\n    \"rate\": 1.1\n  },\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"period\": \"2023-01-15\",\n    \"from_currency\": \"from_currency\",\n    \"to_currency\": \"to_currency\",\n    \"rate\": 1.1\n  }\n]")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.gappify.com/v1/fx-rates")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "[\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"period\": \"2023-01-15\",\n    \"from_currency\": \"from_currency\",\n    \"to_currency\": \"to_currency\",\n    \"rate\": 1.1\n  },\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"period\": \"2023-01-15\",\n    \"from_currency\": \"from_currency\",\n    \"to_currency\": \"to_currency\",\n    \"rate\": 1.1\n  }\n]"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.gappify.com/v1/fx-rates")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("[\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"period\": \"2023-01-15\",\n    \"from_currency\": \"from_currency\",\n    \"to_currency\": \"to_currency\",\n    \"rate\": 1.1\n  },\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"period\": \"2023-01-15\",\n    \"from_currency\": \"from_currency\",\n    \"to_currency\": \"to_currency\",\n    \"rate\": 1.1\n  }\n]")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.gappify.com/v1/fx-rates', [
  'body' => '[
  {
    "source_system_id": "source_system_id",
    "period": "2023-01-15",
    "from_currency": "from_currency",
    "to_currency": "to_currency",
    "rate": 1.1
  },
  {
    "source_system_id": "source_system_id",
    "period": "2023-01-15",
    "from_currency": "from_currency",
    "to_currency": "to_currency",
    "rate": 1.1
  }
]',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.gappify.com/v1/fx-rates");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "[\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"period\": \"2023-01-15\",\n    \"from_currency\": \"from_currency\",\n    \"to_currency\": \"to_currency\",\n    \"rate\": 1.1\n  },\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"period\": \"2023-01-15\",\n    \"from_currency\": \"from_currency\",\n    \"to_currency\": \"to_currency\",\n    \"rate\": 1.1\n  }\n]", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  [
    "source_system_id": "source_system_id",
    "period": "2023-01-15",
    "from_currency": "from_currency",
    "to_currency": "to_currency",
    "rate": 1.1
  ],
  [
    "source_system_id": "source_system_id",
    "period": "2023-01-15",
    "from_currency": "from_currency",
    "to_currency": "to_currency",
    "rate": 1.1
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.gappify.com/v1/fx-rates")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```